<?php if (!defined('PmWiki')) exit(); 
/*  copyright 2008 Henrik Bechmann, Toronto, Canada.
    This file is distributed under the terms of the GNU General Public 
    License as published by the Free Software Foundation; either 
    version 2 of the License, or (at your option) any later version.  

    This module enables toggling of the display style attribute of block elements. 

   (:togglehide targetid default=show|hide showtext="Show widget" hidetext="Hide widget" float=left|right|none focustarget=focustargetid:)
	targetid is the id of the block to toggle
	default=startup link text selector (default is hide)
	showtext: default="Show"
	hidetext: default="Hide"
	showflyover: (optional) text shown in link flyover window (title attribute) when showing block
	hideflyover: (optional) text shown in link flyover window (title attribute) when hiding block
	showimage: markup format. If showimage is set and showtext is not, then the default showtext does not apply
	hideimage: markup format. If hideimage is set and hidetext is not, then the default hidetext does not apply
	float:default="right"
	focustarget: (optional)  default = blank. Focus target specifies the element id of the element to which to return focus after the toggle operation
 */
$RecipeInfo['ToggleHide']['Version'] = '2008-5-29';

$HTMLHeaderFmt['togglehide']='
<script type="text/javascript" src="$FarmPubDirUrl/togglehide/togglehide.js"></script>
';
Markup('togglehide', 'directives',
  '/\\(:togglehide\\s*(.*?):\\)/ei',
  "Keep(ToggleHide(PSS('$1')))");
  
function ToggleHide($arguments) {
$args=ParseArgs($arguments);

if (!$args[''][0])
	return "(:togglehide $arguments:)";
$theTargetID = $args[''][0];
$theDefault=($args['default']?$args['default']:"hide");
$theFloat=($args['float']?$args['float']:"right");
$theDefaultText=
	($theDefault=='show')?
		($args['hidetext']?$args['hidetext']:($args[hideimage]?'':'Hide')):
		($args['showtext']?$args['showtext']:($args[showimage]?'':'Show'));
$theDefaultFlyover=
	($theDefault=='show')?
		($args['hideflyover']?$args['hideflyover']:''):
		($args['showflyover']?$args['showflyover']:'');
$theTitleAttribute='';

if ($args['showimage'])
	$args['showimage']=MakeToggleImg($pagename,$args['showimage']);
if ($args['hideimage'])
	$args['hideimage']=MakeToggleImg($pagename,$args['hideimage']);

$theDefaultImage=
	($theDefault=='show')?$args['hideimage']:$args['showimage'];
	
if ($theDefaultFlyover) $theTitleAttribute="title=\"".$theDefaultFlyover."\"";
$argumentnamelist=array('showtext','hidetext','focustarget','showflyover','hideflyover','showimage','hideimage');
$theArguments=array();
foreach ($argumentnamelist as $v) {
	if ($args[$v])
		$theArguments[$v]=$args[$v];
}
$theArgumentStrings=array("targetid:'$theTargetID'");
foreach($theArguments as $k => $v) {
	$theArgumentStrings[]="$k:\"$v\"";
}
$theArgumentString="{" . htmlspecialchars(implode(",",$theArgumentStrings),ENT_QUOTES) . "}";
$htmlstring="<a href='javascript:void(0)' onclick='togglehide(this,$theArgumentString)' style='margin-bottom:0;float:$theFloat' $theTitleAttribute>$theDefaultImage$theDefaultText</a>";
return $htmlstring;
}

function MakeToggleImg($pagename,$txt) {
  global $LinkPattern,$LinkFunctions,$UrlExcludeChars,$ImgExtPattern,$ImgTagFmt;
  if (preg_match("/(($LinkPattern)([^$UrlExcludeChars]+$ImgExtPattern))(\"(.*)\")?$/",$txt,$tm)) 
    $txt = $LinkFunctions[$tm[2]]($pagename,$tm[2],$tm[3],@$tm[5],
      $tm[1],$ImgTagFmt);
  return $txt;
}
